LO-FAT APIs and Keywords
========================

NOTES:
1: Functions implemented in the python library as abc_def_xyz() is available as
   keyword "Abc Def Xyz" in robot framework resources and test cases.
2: Parts of a keyword should be separated by a single space.
3: Arguments should be separated by a tab (from the keyword and each other)

Keywords implemented in RemoteUi.py
-----------------------------------
Keywords implemented in the RemoteUi python library. The reason for implementing
them in the python library is to leverage the flexibility of python language and
reduce the syntax complexity of robotframework.

* Select Repositories	<page>	<type>	<filter (optional)>
  For selecting Source/Destination Repositories in Imaging/Case Verify/Push tasks
  - Select Repositories	Image|Hash|Wipe|Push	Source|Target	"^SAS_|SATA"|"SAS_D1"|"PCIe_D1"
  - select_repositories(page, type, filter=None)
    page: Image, Hash, Wipe, Push
	type: Target, Source
	filter: bay name filter; can be a bay name or bay name pattern

* Select Drives	<page>	<type>	<filter (optional)>
  For selecting Source/Destination drives in Imaging/Cloning/Hash/Wipe tasks
  - Select Drives	Image|Hash|Wipe|Push	Source|Target	"^SAS_|SATA"|"SAS_D1"|"PCIe_D1"
  - select_drives(page, type, filter=None)
    page: Image, Hash, Wipe, Push
	type: Target, Source
	filter: bay name filter; can be a bay name or bay name pattern

* Create Directory Path	<path>
  For creating a directory structure in clone_capture_path_dialog; used for
  creating a nested capture path in drive-to-file or file-to-file destination.
  - Create Directory Path	abc/def/ghi
  - create_directory_path(path)
	path: '/' seperated directory path

* Select Directory Path	<dialog>	<path>
  For Selecting a directory path in a given open dialog.
  - Create Directory Path	abc/def/ghi
  - select_directory_path(dlgname, path):
	path: '/' seperated directory path

* Select Repository Path	<page>	<type>	<repo>	<path>
  Select repository with a custom destination path.
  - Select Repository Path	Image|Hash|Push	Master|Target	SAS_D2	test3/test4/test5
  - select_repository_path(op, type, filter, path)
    page: Image, Hash, Push
	type: Master, Target
	filter: repo name filter; can be a repo name or repo name pattern
	path: path in the repository to select

* Select Case	<page>	<type>	<repo>	<path>
  Select a case from a repository.
  - Select Case	Image|Hash|Push	Master|Target	SAS_D2	test3/test4/test5
  - select_case(op, type, repo, path)
    page: Image, Hash, Push
	type: Master, Target
	repo: repo name filter; can be a repo name or repo name pattern
	path: path in the repository to select

* Get Task Status <task>
  Get Status of a task from progress bar
  - Get Task Status Wipe 2
  - get_task_status(task)
	task: is of the form OP:N; where OP is one of Image/Clone/Hash/Wipe/Push and N: 1 to 5

* Wait For Tasks <list of tasks>
  To wait for completion of a task or a list of tasks
  - Wait For Tasks<tab>Create List<tab>Image:2<tab>Hash:1
  - wait_for_tasks(tasks)
    tasks: list of tasks of the form type:num

* Is Task Running <task>
  To check if a task is running
  - Is Task Running	Hash:2
  - is_task_running(task)
	task: is of the form OP:N; where OP is one of Image/Clone/Hash/Wipe/Push and N: 1 to 5

* Go To Task <task>
  Select task tab on the UI
  - Go To Task Hash:2
  - go_to_task(task)
	task: is of the form OP:N; where OP is one of Image/Clone/Hash/Wipe/Push and N: 1 to 5

* Add Tasks <page> <num (optional)>
  Add tasks for operation
  - Add Tasks Hash 2
  - add_tasks(page, num=1)
    page: Image, Hash, Wipe, Push
	num: 1 to 5 - optional

* Delete All Tasks <page>
  Delete all tasks for operation
  - Delete All Tasks Hash
  - delete_all_tasks(page)
    page: Image, Hash, Wipe, Push

* Go To Page <page>
  Switch to page
  - Go To Page Task Macro
  - go_to_page(page)
    page: Image, Hash, Wipe, Push

* Take Screenshot <name>
  Take screenshot of current page
  - Take Screenshot image_settings
  - take_screenshot(name)
    name: name of file (extension will be .png)

* Click On <element>
  Click on a UI element
  - Click On	//div[@id="clone_settings_btn"]
  - click_on(element)
    element: css or xpath id of element

* Click Ok <dialog>
  Click Ok button in a dialoag
  - Click Ok	wipe_format_dialog
  - click_ok(dialog)
    dialog: dialog div name

* Click Scroll Down <dialog>
  Click scroll down button in a dialoag
  - Click Scroll Down	push_case_select
  - click_scroll_down(dialog)
    dialog: dialog div name

* Click Scroll Up <dialog>
  Click scroll up button in a dialoag
  - Click Scroll Up	push_case_select
  - click_scroll_up(dialog)
    dialog: dialog div name

* Is Visible <element>
  Check if UI element is visible
  - Is Visible	//div[@id="clone_settings_btn"]
  - is_visible(element)
    element: css or xpath id of element

* Is Enabled <element>
  Check if UI element is interactable
  - Is Enabled	//div[@id="clone_settings_btn"]
  - is_enabled(element)
    element: css or xpath id of element

* Select File Capture Dirs <list of paths>
  Select multilpe directory paths from file-to-file source
  - select_file_capture_dirs(dirs=[])
    dirs: list of directory paths

* Delete Network Repository	<repo name>
  Find and delete network repository entry
  - delete_network_repository(name)
    name: name os repository entry

* Add Network Repository	<name>	<path>	<workgroup>	<user>	<passwd>	<role>	<source>
  Add a network repository
  - Add Network Repository	nas	192.168.1.23/upload	WORKGROUP|NONE	logicube|NONE	logicube|NONE	Source|Destination|Both	Any|Lan1|Lan2
  - add_network_repository(name, path, domain, user, passwd, role, source)
    name: name of repository entry
	path: network share path
	domain: domain name or NONE
	user: username or NONE
	passwd: password or NONE
	source: source interface, Any, Lan1 or Lan2...

Keywords implemented in resource.ui.robot
-----------------------------------------
Keywords implemented in the resource library. These are higher level
function keywords that are based on low level functionality provided
by the RemoteUi And XmlRpcApi python libraries.

* Load Remote UI
  Make sure browser instance is open; should be called atleast once in a test suite/script.

* Set Hash Task Method	<hash method>
  Set Hash Method type for a hash task
  - Set Hash Task Method	SHA1|SHA256|MD5

* Set Imaging Mode	<imaging mode>
  Set Mode for an imaging task
  - Set Imaging Mode	DriveToDrive|FileToDrive|DriveToFile|FileToFile|PartToFile|NetToFile|MobileToFile

* Set Clone Hash Method	<hash method>	<verify>
  Setup hash method for Mirror/Clever Clone
  - Set Clone Hash Method	SHA1|SHA256|MD5	True|False

* Set Image Hash Method	<hash method>	<verify type>
  Set imaging task hash method
  - Set Image Hash Method	SHA1|SHA256|MD5|SHA1MD5|SHA1SHA256|MD5SHA256	NO|PRIMARY|BOTH

* Set Image Method	<capture method>	<segment size>
  Set imaging task method
  - Set Image Method	DD|E01|EX01|DMG	2GB|4GB|8GB|16GB|WHOLEDISK

* Set Image Compression	True|False

* Set Wipe Format	<filesystem>	<encrypt>
  - Set Wipe Format	NTFS|EXT4|EXFAT|FAT32|EXT3|EXT2|HFS+	True|False

* Start Task	<operation>:<task id>
  - Start Task	Image:4

* Wait For Task	<operation>:<task id>
  - Wait For Task	Image:5

* Start All Tasks	[tasks]
  - Start All Tasks	[Image:1, Wipe:2]

* Confirm Task Successful	<task>
  - Confirm Task Successful	Image:1

* Confirm All Tasks Successful	[tasks]
  - Confirm All Tasks Successful	['Image:1', 'Wipe:2']

* Set F2F Method	<output format>
  - Set F2F Method	L01|LX01|DIR|MFT|ZIP

* Set F2F Segment Settings	<segment size>	<compression>
  - Set F2F Segment Settings	2GB|4GB|8GB|16GB|WhoeDisk	True|False

* Select F2F Source Path	<list of path>
  - @{dirs}=	Create List	partn-2_FAT32/EFI/Microsoft/Recovery	partn-2_FAT32/System Volume Information/ClientRecoveryPasswordRotation
  - Select F2F Source Path	${dirs}

Keywords implemented in resource.be.robot
-----------------------------------------
These keywords implement functionality for backend automated test scripts
* Set Task Configuration	<task> <config>
  - Set Task Configuration	Image:1|...|Push:5 &{cfg}

* Set Wipe Format	<task> <fs> <enc>
  - Set Wipe Format	Wipe:1|...|Wipe:5 ntfs|ext4|exfat|fat32|ext3|ext2|hfs+	${true}|${false}

* Set Imaging Config	<task> <mode> <segment size> <comp>
  - Set Imaging Config	Image:1|...|Image:5 DriveToE01|DriveToEx01|DriveToDD|DriveToDMG	2Gb|4Gb|8Gb|16Gb|WholeDisk	Default|None

* Start Task	<task>
  - Start Task	Image:1|Wipe:3|Hash:1|Push:5

* Start All Tasks	[tasks]
  - Start All Tasks	[Image:1, Wipe:2]

* Confirm Task Successful	<task>
  - Confirm Task Successful	Image:1

* Confirm All Tasks Successful	[tasks]
  - Confirm All Tasks Successful	['Image:1', 'Wipe:2']

Keywords implemented in XmlRpcApi.py
------------------------------------
Keywords implemented in the XmlRpcApi python library. These keywords provide direct
access to the backend via XML-RPC Api calls.

* Get Host Statistics
  Dump and get statistics page contents for host
  - get_host_statistics()

* Get All Bays <filter (optional)>
  Get a list of available & connected bay names.
  - get_all_bays(filter=None)
    filter: bay name filter; can be a bay name or bay name pattern

* Get Source Bays
  Get a list of available & connected source bay names.
  - get_source_bays()

* Get Destination Bays
  Get a list of available & connected destination bay names.
  - get_destination_bays()

* Get Source Drives
  Get a list of available & connected source drive structures (drive details).
  - get_source_drives()

* Get Destination Drives
  Get a list of available & connected destination drive structures (drive details).
  - get_destination_drives()

* Is Task Ready <task>
  Check if a task is ready/reserved
  - Is Task Ready Image:1
  - is_task_ready(task)
	task: is of the form OP:N; where OP is one of Image/Clone/Hash/Wipe/Push and N: 1 to 5

* Power Cycle Bay <bay name>
  Power Cycle a locally connected bay; USB not included.
  - power_cycle_bay(bay)

* Get Source Repos
  Get a list of available & mounted source repository names.
  - get_source_repos()

* Get Destination Repos
  Get a list of available & connected destination repository names.
  - get_destination_repos()

* Is Network Repo Mounted <repo path>
  Check if network repository is mounted.
  - is_network_repo_mounted(path)

* Is Iscsi Portal Connected <portal ip>
  Check if iSCSI portal is connected.
  - is_iscsi_portal_connected(ip)

* Get All Pairs
  Get a list of source destination pairs; the pairing is sas to sas/sata, usb to usb, pcie to pcie ...
  - get_all_pairs()
  Following are extension for specific type pairs
  - Get Sas Sata Pairs: get_sas_sata_pairs()
  - Get Pcie Pairs: get_pcie_pairs()
  - Get Usb Pairs: get_usb_pairs()
  - Get Tbt Pairs: get_tbt_pairs()

* Get Host Statistics
  Get contents of statics page for host
  - get_host_statistics()

* Task Add <task>
  Reserve a task id of a specific operation type; "Task Add<tab>Image:2" will reserve task id 2 of Image type.
  - task_add(task)
	task: is of the form OP:N; where OP is one of Image/Clone/Hash/Wipe/Push and N: 1 to 5

* Task Delete <task>
  Release a task id of a specific operation type; "Task Delete<tab>Image:2" will relese task id 2 of Image type.
  - task_delete(self, task):
	task: is of the form OP:N; where OP is one of Image/Clone/Hash/Wipe/Push and N: 1 to 5

* Task Delete All <operation type> 
  Release all tasks of a given operation type.
  - task_delete_all(opr)

* Task Set Targets	<task>	<filter(optional)>
  Select targets for a task; either all or the ones that match a certain pattern.
  - task_set_targets(task, filter=None)
	task: is of the form OP:N; where OP is one of Image/Clone/Hash/Wipe/Push and N: 1 to 5

* Task Set Master	<task>	<filter(optional)>
  Select master for a task; either the first source or the first one that matches a certain pattern.
  - task_set_master(task, filter=None)
	task: is of the form OP:N; where OP is one of Image/Clone/Hash/Wipe/Push and N: 1 to 5

* Task Set Repositories	<task>	<filter(optional)>
  Select destination repositories for a task; either all or the ones that match a certain pattern.
  - task_set_repositories(task, repos=None)
	task: is of the form OP:N; where OP is one of Image/Clone/Hash/Wipe/Push and N: 1 to 5

* Task Set Hash	<task>	<hash type>	<verify (optional)>
  Set Hash type for task and optional verify. verify can be True/False or None/Primary/Both for dual hash.
  - task_set_hash(task, hash='SHA-1', vfy=None)
	task: is of the form OP:N; where OP is one of Image/Clone/Hash/Wipe/Push and N: 1 to 5

* Task Set Config	<task>	<config dictionary>
  Set configuration settings for a task.
  - task_set_config(task, cfg)
	task: is of the form OP:N; where OP is one of Image/Clone/Hash/Wipe/Push and N: 1 to 5

* Task Run	<task>
  Start executing the task.
  - task_run(task)
	task: is of the form OP:N; where OP is one of Image/Clone/Hash/Wipe/Push and N: 1 to 5

* Is Task Ready	<task>
  Check if task is in TASK_RESERVED state.
  - is_task_ready(task)
	task: is of the form OP:N; where OP is one of Image/Clone/Hash/Wipe/Push and N: 1 to 5

* Is Task Running	<task>
  Check if a task is in TASK_WORKING state.
  - is_task_running(task)
	task: is of the form OP:N; where OP is one of Image/Clone/Hash/Wipe/Push and N: 1 to 5

* Task Status Get	<task>
  Get the status for a task.
  - task_status_get(task)
	task: is of the form OP:N; where OP is one of Image/Clone/Hash/Wipe/Push and N: 1 to 5

* Task Get Source Hash	<task>
  Get hash calculate for a given source drive from a hash task.
  - task_get_source_hash(task, src)
	task: is of the form OP:N; where OP is one of Image/Clone/Hash/Wipe/Push and N: 1 to 5

* Task Get Expected Hash	<task>
  Get the expected hash generated/setup for a task.
  - task_get_expected_hash(task)
	task: is of the form OP:N; where OP is one of Image/Clone/Hash/Wipe/Push and N: 1 to 5

* Wait For Task Completion	<tasks>
  Wait for a list of tasks to complete execution.
  - wait_for_task_completion(tasks)
