Introduction
============
LOFAT (Low-Fat) stands for LOgicube-Framework-for-Automated-Test. This is aimed
at creating a single framework with libraries to enable both backend and frontend
automated testing.

Auto Test Framework
====================

Test cases are written in robotframework, for ease of understanding
via self documentation and test result reports. The test cases use keywords
implemented in python libraries to access frontend via selenium and backend
via XML-RPC APIs.

<!-- language: lang-none -->

         +-------------------------------------------------+
         |                                                 |
         |              UI/Backend Test Suite              |
         |                                                 |
         +-------------------------------------------------+
                                  |
         +------------------------v------------------------+
         |                                                 |
         |               Robot Test Framework              |
         |                                                 |
         +-------------------------------------------------+
                |               |                  |
         +------v------+ +------v-------+ +--------v-------+
         |             | |              | |                |
         | RemoteUi.py | | XmlRpcApi.py | | SecureShell.py |
         |             | |              | |                |
         +-------------+ +--------------+ +----------------+
               |                |                  |
         +-----v-------+ +------v-------+ +--------v-------+
         |             | |              | |                |
         |   Python    | |    Python    | |     Python     |
         |  Selenium   | |    XML-RPC   | |    Paramiko    |
         |             | |              | |                |
         +-------------+ +--------------+ +----------------+

Directory Structure
-------------------
lofat
  |-lib/
  |  |-modules/
  |  |-resources.ui.robot
  |  |-resources.be.robot
  |  |-variables.robot
  |
  |-testcases/
  |   |-falcon-neo/
  |   |   |-backend/
  |   |   |-ui/
  |   |-<platform>/
  |   |   |-backend/
  |   |   |-ui/

* lib/: This directory contains the robot test framework library scripts.
* lib/modules/: This directory contains python libraries used by robot framework resources.
* lib/resources.ui.robot: This file contains resources robot test UI framework.
* lib/resources.ui.robot: This file contains resources robot test backend framework.
* lib/variables.robot: This directory contains the robot test framework library scripts.
* testcases/: This directory contains test cases for each platform.
* testcases/falcon-neo/: This directory contains backend and UI test cases for Falcon-NEO.
* run_test: bash script to execute the tests
* KEYWORDS.md: documentation of Framework Keywords

Preparing Linux PC for Automated UI test setup
==============================================
sudo apt update
sudo apt-get install python3-pip
pip3 install robotframework
pip3 install robotframework-selenium2library
pip3 install paramiko
sudo apt install chromium-driver
sudo apt install chromium

Clone automated test Repository
-------------------------------
git clone ssh://git@192.168.1.85:7999/qat/lofat.git

Running Test Scripts
--------------------
To run the tests on the Linux PC, execute the following on the commandline
$ run_test -h <host name/ip> -t <testcase fullpath> [-l <logs dir>] [-r <results dir>] [-H]

NOTES:
1. By default, the test are run headless. Meaning the chrome instance wont show and you wont be able to
   see how the tests are navigating the UI. Use "-H" argument to run tests in headful mode to see UI.
