#!/usr/bin/python2
# -*- coding: utf-8 -*-

import socket
import sys
import threading
import time
import paramiko
from pprint import pprint

class SecureShell(paramiko.SSHClient):
	def __init__(self, host, user='logicube', passwd='logicube'):
		self.host = host
		self.user = user
		self.passwd = passwd
		super(SecureShell, self).__init__()
		self.load_system_host_keys()
		self.set_missing_host_key_policy(paramiko.AutoAddPolicy())

	def Login(self):
		try:
			self.connect(self.host, 22, self.user, self.passwd, timeout=5, banner_timeout=5)
		except paramiko.AuthenticationException:
			pprint("Authentication Failed! host={0}".format(self.host))
			pprint("Please check username and password")
			return False

		except paramiko.SSHException:
			pprint("Failed to connect host={0}".format(self.host))
			pprint("Make sure hostname is correct and that it is up and running")
			return False

		except Exception as e:
			pprint("Failed to connect host={0} - {1}".format(self.host, str(e)))
			return False
		return True

	def Do(self, cmd='', res=None):
		try:
			if not self.get_transport().is_active():
				pprint("SSH connection to '{0}' not active".format(self.host))
				if not self.connect():
					pprint("SSH re-connect to '{0}' failed".format(self.host))
					return False
			stdin, stdout, stderr = self.exec_command(cmd, timeout=30)
			if res is not None:
				for line in stdout:
					res.append(line)
				for line in stderr:
					res.append(line)
		except Exception as e:
			pprint("Failed to do '{0}' on '{1}' - {2}".format(cmd, self.host, str(e)))
			return False

		return True

	def Execute(self, cmd='', res=None):
		if self.Login():
			stdin, stdout, stderr = self.exec_command(cmd)
			if res is not None:
				for line in stdout:
					res.append(line)
				for line in stderr:
					res.append(line)
			self.close()
			return True
		return False

	def drop_all_checkpoints(self):
		return self.Execute('sudo rm -rf /var/lib/logicube/ckpoints/*')
